function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function (global, factory) {
  (typeof exports === "undefined" ? "undefined" : _typeof(exports)) === 'object' && typeof module !== 'undefined' ? factory(exports) : typeof define === 'function' && define.amd ? define(['exports'], factory) : (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['request-animation-frame-polyfill'] = {}));
})(this, function (exports) {
  'use strict';
  /**
   * Thanks for following contributor of codes
   * https://gist.github.com/1866474
   * http://paulirish.com/2011/requestanimationframe-for-smart-animating/
   * http://my.opera.com/emoller/blog/2011/12/20/requestanimationframe-for-smart-er-animating
   * https://github.com/Financial-Times/polyfill-library/blob/master/polyfills/requestAnimationFrame/polyfill.js
  **/

  var uId = 1;

  var uniqueId = function uniqueId() {
    return uId++;
  }; // We use `self` instead of `window` for `WebWorker` support.


  var root = (typeof self === "undefined" ? "undefined" : _typeof(self)) === 'object' && self.self == self ? self : (typeof global === "undefined" ? "undefined" : _typeof(global)) === 'object' && global.global == global ? global : {};
  var nowOffset = Date.now(); // use performance api if exist, otherwise use Date.now.
  // Date.now polyfill required.

  var pnow = function pnow() {
    if (root.performance && typeof root.performance.now === 'function') {
      return root.performance.now();
    } // fallback


    return Date.now() - nowOffset;
  };

  var reservedCBs = {};
  var lastTime = Date.now();

  var polyfillRaf = function polyfillRaf(callback) {
    if (typeof callback !== 'function') {
      throw new TypeError(callback + ' is not a function');
    }

    var currentTime = Date.now();
    var gap = currentTime - lastTime;
    var delay = gap > 16 ? 0 : 16 - gap;
    var id = uniqueId();
    reservedCBs[id] = callback; // keys(reservedCBs).length > 1 의미는 이미 setTimeout 이 걸려있는 경우.
    // 함께 callback 이 실행될 수 있게 reservedCBs 에만 추가해주고 return

    if (Object.keys(reservedCBs).length > 1) return id;
    setTimeout(function () {
      lastTime = currentTime;
      var copied = reservedCBs;
      reservedCBs = {};
      Object.keys(copied).forEach(function (key) {
        return copied[key](pnow());
      });
    }, delay);
    return id;
  };

  var polyfillCaf = function polyfillCaf(id) {
    delete reservedCBs[id];
  };

  var vendorPrefixes = ['', 'webkit', 'moz', 'ms', 'o'];

  var getRequestAnimationFrame = function getRequestAnimationFrame(vp) {
    if (typeof vp !== 'string') return polyfillRaf;
    if (vp === '') return root['requestAnimationFrame'];
    return root[vp + 'RequestAnimationFrame'];
  };

  var getCancelAnimationFrame = function getCancelAnimationFrame(vp) {
    if (typeof vp !== 'string') return polyfillCaf;
    if (vp === '') return root['cancelAnimationFrame'];
    return root[vp + 'CancelAnimationFrame'] || root[vp + 'CancelRequestAnimationFrame'];
  };

  var find = function find(arr, predicate) {
    var i = 0;

    while (arr[i] !== void 0) {
      if (predicate(arr[i])) return arr[i];
      i = i + 1;
    }
  };

  var vp = find(vendorPrefixes, function (vp) {
    return !!getRequestAnimationFrame(vp);
  });
  var raf = getRequestAnimationFrame(vp);
  var caf = getCancelAnimationFrame(vp); // References:
  // Browser export as a global

  root.requestAnimationFrame = raf;
  root.cancelAnimationFrame = caf; // Node Export

  if (typeof module !== "undefined" && module.exports) {
    module.exports = {
      requestAnimationFrame: raf,
      cancelAnimationFrame: caf
    };
  }

  var index = {
    requestAnimationFrame: raf,
    cancelAnimationFrame: caf
  };
  /*
   * Below 4 methods should be available on consumer side:
   *
   * <script src="https://.../index.umd.min.js"></script>
   * requestAnimationFrame, cancelAnimationFrame
   *
   * const {requestAnimationFrame, cancelAnimationFrame} require('request-animation-frame-polyfill')
   * const rafp require('request-animation-frame-polyfill')
   * rafp.requestAnimationFrame, rafp.cancelAnimationFrame
   *
   * import rafp from 'request-animation-frame-polyfill'
   * rafp.requestAnimationFrame, rafp.cancelAnimationFrame
   *
   * import {requestAnimationFrame, cancelAnimationFrame} from 'request-animation-frame-polyfill'
   * import * as rafp from 'request-animation-frame-polyfill'
   * rafp.requestAnimationFrame, rafp.cancelAnimationFrame
  */

  exports.cancelAnimationFrame = caf;
  exports.default = index;
  exports.requestAnimationFrame = raf;
  Object.defineProperty(exports, '__esModule', {
    value: true
  });
});
